//--------------------------------------------------------------------//
//                  Generated by RSTK                                 //
//                      rs_syndec.c                                   //
//                                                                    //
//--------------------------------------------------------------------//
#include <stdio.h>
#include "proto_types.h"
/**********************************************************/
/* Berlenkamp-Massey Error Locator Algorithm              */
/**********************************************************/
void berl_mas( int chk_sym, char *s, char *Lam, int dbg )
{
int i,j,t,r,v ;
int L ;
unsigned char S_x[3] ;
unsigned char lambda[3] ;
unsigned char T_x[3] ;
unsigned char B_x[3] ;
unsigned char delta_R ;
unsigned char poly_x1[2] = {0,1}  ;
unsigned char temp[3] ;
int deg ;
unsigned char inv_delta_R ;
  /* Clear work space */
  for (i=0; i<3; i++) {
    S_x[i] = 0 ;
    lambda[i] = 0 ;
    T_x[i] = 0 ;
    B_x[i] = 0 ;
    temp[i] = 0 ;
  }
  /* Set to initial conditions */
  t=0;
  r = 0 ;
  delta_R = 0 ;
  L = 0 ;
  lambda[0] = 1 ;
  B_x[0] = 1 ;
  v = 2*chk_sym ; 
  /* Copy syndromes to new workspace syndrome list */
  //for (i=0; i<v+1; i++) {
    //S_x[i+1] = *s++ ;
  //}
  for (i=0; i<v; i++) {
    S_x[i] = *s++ ;
  }
  for ( t=0; t<v; t++) {
    if (dbg == 1) printf(" ------------Iteration----------- %d  \n", t) ;
    //r = r + 1 ;
    delta_R = 0 ;
      if (dbg == 1) {
        printf("L(x) = ") ;
        for (i=0; i<= v; i++)  
           printf("%2x ", lambda[i]) ;
        printf("\n") ;
      }
      if (dbg == 1) { 
        printf("x*B(x) = ") ;
        for (i=0; i<= v; i++)
           printf("%2x ", B_x[i]) ;
        printf("\n") ;
      }
    for (j=0; j<=L; j++) {
       //delta_R = gfmul_ab(lambda[j],S_x[r-j]) ^ delta_R ; 
       delta_R = gfmul_ab(lambda[j],S_x[r-j]) ^ delta_R ; 
       if (dbg == 1) printf("delta_R = %2x\n",delta_R) ;
    }
    r = r + 1 ;
    if ( delta_R != 0 ) {
      /*    B(x) by delta R*x   */
      poly_x1[1] = delta_R ;
      gf_poly_mul(poly_x1, 1,  B_x, v, temp, &deg) ;
      if (dbg == 1) {
        printf("x*B(x) = ") ;
        for (i=0; i<= v; i++)
           printf("%2x ", temp[i]) ;
        printf("\n") ;
      }
      /* Add lambda(x) to delta_R*x*B(x) */
      gf_poly_add(lambda, v, temp, v, T_x, &deg) ;
      if (dbg == 1) {
        printf("T(x) = Lambda + x*B(x) = ") ;
        for (i=0; i<= v; i++) 
           printf("%2x ", T_x[i]) ;
        printf("\n") ;
      }
      if (2*L <= r - 1) {
        if (dbg == 1) printf(" ++ 2L<= r-1 ++ \n") ;
        inv_delta_R = gf_inverse(delta_R) ;
        if (dbg == 1) printf("Inverse Delta R = %2x \n", inv_delta_R) ;
        gf_poly_conmul( inv_delta_R, lambda, v,  temp, v, &deg) ;
        if (dbg == 1) printf("B(x) =") ;
        for (i=0; i<= v; i++) {
          B_x[i] = temp[i] ;
            if (dbg == 1) printf("%2x ", B_x[i]) ;
        }
        for (i=0; i<= v; i++)
          lambda[i] = T_x[i] ;
        if (dbg == 1) {
          printf("\nL(x) = ") ;
          for (i=0; i<= v; i++) 
             printf("%2x ", lambda[i]) ;
          printf("\n") ;
        }
        if (dbg == 1) printf("\n") ;
          L = r - L ;
      }
      else {
        if (dbg == 1) printf(" ** 2L > r-1 ** \n") ;
        for (i=0; i<= v; i++)
          lambda[i] = T_x[i] ;
        poly_x1[1] = 1 ;
        gf_poly_mul(poly_x1, 1, B_x, v, temp, &deg) ;
        for (i=0; i<= v; i++)
          B_x[i] = temp[i] ;
        if (dbg == 1) { 
          printf("L(x) =") ;
          for (i=0; i<= v; i++) 
             printf("%2x ", lambda[i]) ;
          printf("B(x) =") ;
          for (i=0; i<= v; i++)
             printf("%2x ", B_x[i]) ;
          printf("\n") ;
        }
      } 
    }
    else {
        poly_x1[1] = 1 ;
        gf_poly_mul(poly_x1, 1, B_x, v, temp, &deg) ;
        for (i=0; i<= v; i++)
          B_x[i] = temp[i] ;
    }
  } 
  for (i=0; i<= v; i++) 
    *Lam++ = lambda[i] ;
  printf("L = %d\n", L ) ;
}
