/*****************************************************************/
/*                                                               */
/*           Reed Solomon Codec                                  */
/*             rs(15,13)                                         */
/*                                                               */
/*                                                               */
/*****************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "proto_types.h"
#define  GF_FIELD  16 
unsigned char syndromes[6]  ;

unsigned char msg_in[16] ;
unsigned char enc_msg_out[16] ;

unsigned char Lambda[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}  ;
int      num_roots ;
unsigned char lam_roots[10] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}  ;
unsigned char err_corr_val[10]  ;

main()
{
int i ;
unsigned char s1,s2,s3,s4,s5,s6,syn_zero ;


  //for (i=0; i<GF_FIELD; i++)
	//msg_in[i] = 0 ;

	//msg_in[12] = 1 ;
  for (i=0; i<GF_FIELD-2; i++)
	msg_in[i] = i ;

/*  ---------------------  Start of RS Encode ------------------------------------ */

  /* 15,13 encoder */
  rs_encode(15,13,0) ;  

  printf(" ------------ Transmitted Message -------------\n") ;
  for (i=0; i< GF_FIELD ; i++) {
     if (i%16 == 0)
         printf("\n") ;
     printf("%2x,",enc_msg_out[i]) ;
  }
  printf("\n %s", enc_msg_out) ;
  printf("\n\n\n") ;

/*  ---------------------  Start of RS Decode        ----------------------------- */
  
  // Force an error
  enc_msg_out[12] = 4  ;

  printf(" ------------ Received Message -------------\n") ;
  for (i=0; i< GF_FIELD ; i++) {
     if (i%16 == 0)
         printf("\n") ;
     printf("%2x,",enc_msg_out[i]) ;
  }
  printf("\n\n\n") ;

  dec_syn_calc(15, &s1, &s2, &syn_zero) ;
  //dec_syn_calc(15, &s1, &s2, &s3, &s4, &s5, &s6, &syn_zero) ;

  syndromes[0] = s1 ;
  syndromes[1] = s2 ;
  syndromes[2] = s3 ;
  syndromes[3] = s4 ;
  syndromes[4] = s5 ; 
  syndromes[5] = s6 ;
  for(i=0; i<2; i++)
     printf("s[%d] = %2x\n", i, syndromes[i]) ;
  printf("Received Syndrome Computation = %x\n\n", syn_zero) ;

  /* Locate Errors in Message Block */
  berl_mas(1, syndromes, Lambda, 1 ) ;
  chien_search_hw(2, Lambda, &num_roots, lam_roots ) ;
  forney(1, syndromes, Lambda, num_roots, lam_roots, err_corr_val, 1 ) ;

  /* Correct Message */
  for (i=0; i< num_roots ; i++) {
     printf("Error Location = %d , Correction Value = %2x\n", lam_roots[i], err_corr_val[i]) ;

     enc_msg_out[lam_roots[i] - 1] = enc_msg_out[lam_roots[i] - 1] ^ err_corr_val[i] ;
     //enc_msg_out[lam_roots[i]] = enc_msg_out[lam_roots[i]] ^ err_corr_val[i] ;
  }
  printf("\n") ;
  printf(" ------------ Corrected Received Message -------------\n") ;
  for (i=0; i< GF_FIELD ; i++) {
     if (i%16 == 0)
         printf("\n") ;
     printf("%2x,",enc_msg_out[i]) ;
  }
  printf("\n\n\n") ;
}

