//--------------------------------------------------------------------//
//                  Generated by RSTK                                 //
//                      rs_forney.c                                   //
//                                                                    //
//--------------------------------------------------------------------//
/****************************************************************/
/* Forney algorithm for error evaluator polynomial & correction */
/****************************************************************/
#include <stdio.h>
#include "proto_types.h"
extern unsigned char gf_alpha_tbl[] ;        // Alpha GF Feild (a^n)
extern unsigned char gf_invalpha_tbl[] ;     // Iverse of Alpha GF Feild (a^n)
extern unsigned char gf_powalpha_tbl[] ;     // Power of Alpha GF Feild (a^n)

void forney(v, syn, lam, n_roots, lam_root, corr_val, dbg ) 
int v ;
unsigned char *syn, *lam ;
int n_roots ;
unsigned char *lam_root ;
unsigned char *corr_val ;
int dbg ;
{
 int i, j, m, r ;
unsigned char l[3] ;
unsigned char d_lam[3] ;
unsigned char s[2] ;
unsigned char omega[3] ;
unsigned char norm, om, inv_k_lam, ei ;
unsigned char  k_lam, k_om, z0, z1 ;
unsigned char  roots[1] ;


   for (i=0; i<2; i++) {
     s[i] = 0 ;
   }
   for (i=0; i<3; i++) {
     l[i] = 0 ;
     d_lam[i] = 0 ;
     omega[i] = 0 ;
   }

   for (i=0; i<v; i++) {
     roots[i] = *lam_root++ ;
     if (dbg == 1) printf("Lamda Roots = %d\n",roots[i]) ;
   }

   // Copy string
   for (i=0; i<v; i++) {
     l[i] = *lam++ ;
     d_lam[i] = l[i] ;
     s[i] = *syn++ ;
     if (dbg == 1) printf("lam = %2x\n", l[i]) ;
   }

   //
   // Generate derivative of Lambda by zeroing even powers of 2 in Lambda
   // Note: L'(x) can be calculated as soon as L(x) has been computed by berl_mas()
   //
   for (i=0; i<v; i++) {
     if (i%2 == 0)
       d_lam[i] = 0 ;
     if (dbg == 1) printf("d_lam = %2x\n", d_lam[i]) ;
   }
   for (i=0; i<v; i++) { 
       d_lam[i] = d_lam[i+1] ;
       if (dbg == 1) printf("shifted d_lam = %2x\n", d_lam[i]) ;
   }

   //
   // Note: omega(x) can be calculated as soon as L(x) has been computed by berl_mas()
   // 

   omega[0] = s[0] ;
   for (i=1; i< v; i++) {
       omega[i] = s[i] ;
           for (j=1; j<= i; j++) {
              omega[i] = omega[i] ^ gfmul_ab(s[i-j], l[j]) ;
           }
   }

   for (i=0; i<v; i++)
     if (dbg == 1) printf("omega[%d] = %2x\n", i, omega[i]) ;


   // 
   // Compute O(x)/L'(x)
   //
   for (r=0; r < n_roots; r++) {
     k_lam = 0 ;
     k_om = 0 ;
     k_lam = k_lam ^ d_lam[0] ;
     k_om  = k_om  ^ omega[0] ;


     //
     // Calculate k_om, k_lam for each root found by chien search
     //
     for (i=1; i<v; i++) {
       z0 = gf_alpha_tbl[roots[r]] ;
       z1 = 1 ;
       for (m=1;m<=i; m++)
          z1 = gfmul_ab(z0, z1) ;  // Power of root must be calculated to determine k_lam 
       k_lam = k_lam ^ gfmul_ab(d_lam[i], z1) ;
       printf("Root %d: Derivative of Lambda at root: k_lam = %2x\n", r, k_lam ) ;

       z0 = gf_alpha_tbl[roots[r]] ;
       z1 = 1 ;
       for (m=1;m<=i; m++)
          z1 = gfmul_ab(z0, z1) ;  // Power of root must be calculated to determine k_om 
       printf("Root %d: Evaluation of a^n at root: a_n = %2x\n", r, z1 ) ;

       k_om  = k_om ^ gfmul_ab(omega[i], z1) ;
       printf("Root %d: Evaluation of Omega at root: k_om = %2x\n", r, k_om ) ;
     }


   inv_k_lam = gf_invalpha_tbl[k_lam] ; // To devide O(x) by L'(x) get inverse of L'(x)
   printf("Inverse K_Lam:  = %2x\n", inv_k_lam ) ;

   norm = 0x01 ;  // Normalization factor for base = 0,1
   om = gfmul_ab(k_om, inv_k_lam ) ; // calculate error value 
   ei = gfmul_ab(norm, om) ;         // and normalize to base

   //printf("norm = %2x om = %2x ei = %2x\n", norm, om, ei) ;
   *corr_val++ = ei ;
   } 

}
