//--------------------------------------------------------------------//
//                  Generated by RSTK                                 //
//                      rs_polymath.c                                   //
//                                                                    //
//--------------------------------------------------------------------//
#include <stdio.h>
#include "proto_types.h"
//
// Externals
//
extern unsigned char gf_alpha_tbl[] ;        // Alpha GF Feild (a^n)
extern unsigned char gf_invalpha_tbl[] ;     // Iverse of Alpha GF Feild (a^n)
#define MAX_POLY_ORDER   64 

//
// Workspace
//
unsigned char poly_p1[64] ;
unsigned char poly_p2[64] ;
unsigned char poly_p3[64] ;
unsigned int tmp1[64] ;
unsigned int tmp2[64] ;

void gf_poly_mul(unsigned char *p1, int deg_p1, unsigned char *p2, int deg_p2, unsigned char *p3, int *deg_p3)
{

int i ;
int term ;
int deg ;
int new_deg ;

  for (i=0; i<MAX_POLY_ORDER; i++) {
    tmp1[i] = 0 ;
    tmp2[i] = 0 ;
  }

  new_deg = deg_p1 + deg_p2 ;

  term = 0 ;

  while (term <= deg_p1) {
     i = 0 ;
	 deg = 0 ;
	 while (i <= deg_p2) {
		 tmp1[i+term] = gfmul_ab((unsigned char)p2[i],(unsigned char)p1[term]) ;
		 i = i + 1 ;
		 deg = deg + 1 ;
     }

	 i = 0 ;
	 while (i <= deg) {
		 tmp2[i+term] = gf_add((unsigned char)tmp1[i+term], (unsigned char)tmp2[i+term]) ;
	     i = i + 1 ;
	 }
     tmp1[term] = 0 ;
	 term = term  + 1 ;
	 deg = 0 ;
	}

  for(i=0; i<= new_deg; i++) {
    p3[i] = tmp2[i] ;
  }
*deg_p3 = new_deg ;
}

/* Multiply polynomial by a Constant */
void gf_poly_conmul( unsigned char K, unsigned char *p1, int deg1, unsigned char *p2, int deg2, int *deg )
{
unsigned char *t1  ;
int i ;

  t1 = p1 ;

  for (i=0; i<=deg1; i++) {
    poly_p1[i] = *t1++ ;
  }

  for (i=0; i<=deg1; i++) {
    poly_p1[i] =  gfmul_ab(K, poly_p1[i]) ;
  }

  *deg = deg1 ;

  for(i=0; i<= 9; i++) {
    *p2++ = poly_p1[i] ;
  }

}

// Add two polynomials


void gf_poly_add( unsigned char *p1, int deg1, unsigned char *p2, int deg2, unsigned char *p3, int *deg )
{
unsigned char *t1, *t2 ;
int i, j;

  t1 = p1 ;
  t2 = p2 ;

  for (i=0; i<=deg1; i++) {
    poly_p1[i] = *t1++ ;
  }

  for (i=0; i<=deg2; i++) {
    poly_p2[i] = *t2++ ;
  }

  for (i=0; i<MAX_POLY_ORDER; i++) {
    poly_p3[i] = 0 ;
  }


  if (deg1 >= deg2) 
    j = deg1 ;
  else
    j = deg2 ;

  for (i=0; i<=j; i++) {
    poly_p3[i] = poly_p1[i] ^ poly_p2[i] ;
  }

  *deg = j ;

  for(i=0; i<j; i++) {
    *p3++ = poly_p3[i] ;
  }

}


//
// gf_add(a,b)
//     Add a + b
//
unsigned char gf_add(unsigned char a, unsigned char b)
{

    return (a ^ b) ;

}
/* Find Inverse of a (1/a) */
unsigned char gf_inverse( a )
unsigned char a ;
{

return(gf_invalpha_tbl[a]) ;

}
