--
-- Procedure: chip_reg_access
-- 
--	Chip register access proceedure for internal registers of
--	FPGA/ASIC.
--
library IEEE ;
use IEEE.std_logic_1164.all ;
use std.textio.all ;
--
LIBRARY IEEE ;
use IEEE.std_logic_1164.all ;
--
library IEEE ;
use 	IEEE.std_logic_unsigned.all;
--
--
library arithmetic ;
use arithmetic.std_logic_arith.all ;
--
--
package chip_reg_access is

procedure MC850_cs_device( 
			mode : integer ;
			db_in: integer ;
			ab_in: integer ;
			signal data		: OUT std_logic_vector(7 downto 0) ;
			signal adr		: OUT std_logic_vector(31 downto 0) ;
			signal ts_n		: OUT std_logic ;
		    signal CSn 		: OUT std_logic ; 
		    signal clk 		: IN std_logic ;
			signal RNW		: OUT std_logic ;
			signal OEn		: OUT std_logic ;
		    signal ta_n 	: IN std_logic ) ; 


procedure clk_wait( 	   n   : integer;
					signal clk : std_logic ) ;

end chip_reg_access ;

--
LIBRARY IEEE ;
use IEEE.std_logic_1164.all ;
--
library IEEE ;
use 	IEEE.std_logic_unsigned.all;
--
--
library arithmetic ;
use arithmetic.std_logic_arith.all ;
--
--
package body chip_reg_access is

procedure MC850_cs_device( 
			mode : integer ;
			db_in: integer ;
			ab_in: integer ;
			signal data		: OUT std_logic_vector(7 downto 0) ;
			signal adr		: OUT std_logic_vector(31 downto 0) ;
			signal ts_n		: OUT std_logic ;
		    signal CSn 		: OUT std_logic ; 
		    signal clk 		: IN std_logic ;
			signal RNW		: OUT std_logic ;
			signal OEn		: OUT std_logic ;
		    signal ta_n 	: IN std_logic ) is 

variable adr_in : integer ;
variable data_in : integer ;

begin


	adr	<= conv_std_logic_vector( ab_in, 32 ) ;

	wait until clk = '1' ;
	ts_n <= '0' after 1 ns;

	CSn <= '0' after 1 ns ;

	if ( mode = 0 ) then
		RNW  <= '0' after 1 ns ;
		data <= conv_std_logic_vector( db_in, 8 ) after 1 ns;
		OEn <= '1' ;

	end if ;

	if ( mode = 1 ) then
		RNW <= '1' ;
		OEn <= '0' ;

	end if ;

	wait until clk = '1' ;
	ts_n <= '1' after 1 ns;
	wait until clk = '1' ;

	wait until clk = '1' ;
	wait until clk = '1' ;
	wait until clk = '1' ;
	wait until clk = '1' ;
--
--	while (TA_N = '1') loop
--		wait until clk = '1' ;
--	end loop ;

--	wait until TA_N = '0' ;

	CSn <= '1' after 1 ns ;

	data <= "ZZZZZZZZ" after 1 ns ;

end ;
--
--
--

--
-- Wait N clock periods
--
procedure clk_wait( 	    n  : integer ;
				    signal clk : std_logic ) is
begin
	for n in 1 to n loop
		wait until clk = '1' ;
	end loop ;
end ;

--END;
end chip_reg_access ; 


