------------------------------------------------------------------------
--                  Generated by RSTK                                 --
--                      gf_arith.vhd                                  --
--                                                                    --
------------------------------------------------------------------------
--
--
LIBRARY IEEE ;
use IEEE.std_logic_1164.all ;
--
library IEEE ;
use     IEEE.std_logic_unsigned.all;
--
library IEEE ;
use     IEEE.NUMERIC_STD.all;
--
--
package gf_arith is

function gfmul_1(c : std_logic_vector(3 downto 0)) return std_logic_vector ;
function gfmul_4(c : std_logic_vector(3 downto 0)) return std_logic_vector ;
function gfmul_0(c : std_logic_vector(3 downto 0)) return std_logic_vector ;
function gfmul_ab(a: std_logic_vector(3 downto 0); 
                  b: std_logic_vector(3 downto 0)) return std_logic_vector ;
end package gf_arith ;

package body gf_arith is
--
-- c * a^1
--
function gfmul_1(c : std_logic_vector(3 downto 0)) return std_logic_vector is
variable gfmul_1 : std_logic_vector(3 downto 0) ;
begin
gfmul_1(0) := c(3) ; 
gfmul_1(1) := c(0) xor c(3) ; 
gfmul_1(2) := c(1) ; 
gfmul_1(3) := c(2) ; 
    return (gfmul_1) ;
end gfmul_1 ;
--
-- c * a^4
--
function gfmul_4(c : std_logic_vector(3 downto 0)) return std_logic_vector is
variable gfmul_4 : std_logic_vector(3 downto 0) ;
begin
gfmul_4(0) := c(0) xor c(3) ; 
gfmul_4(1) := c(0) xor c(1) xor c(3) ; 
gfmul_4(2) := c(1) xor c(2) ; 
gfmul_4(3) := c(2) xor c(3) ; 
    return (gfmul_4) ;
end gfmul_4 ;
--
-- GF multiply a*b
--
function gfmul_ab (a : std_logic_vector(3 downto 0); b : std_logic_vector(3 downto 0)) return std_logic_vector is
variable t: std_logic_vector(6 downto 0) ;
variable gfmul_ab: std_logic_vector(3 downto 0) ;
begin
t(0) := (a(0) and b(0)) ;
t(1) := (a(0) and b(1)) xor (a(1) and b(0)) ;
t(2) := (a(0) and b(2)) xor (a(1) and b(1)) xor (a(2) and b(0)) ;
t(3) := (a(0) and b(3)) xor (a(1) and b(2)) xor (a(2) and b(1)) xor (a(3) and b(0)) ;
t(4) := (a(1) and b(3)) xor (a(2) and b(2)) xor (a(3) and b(1)) ;
t(5) := (a(2) and b(3)) xor (a(3) and b(2)) ;
t(6) := (a(3) and b(3)) ;
gfmul_ab(0) := t(0) xor t(4) ; 
gfmul_ab(1) := t(1) xor t(4) xor t(5) ; 
gfmul_ab(2) := t(2) xor t(5) xor t(6) ; 
gfmul_ab(3) := t(3) xor t(6) ; 
    return (gfmul_ab) ;
end gfmul_ab ;
--
-- c * a^0
--
function gfmul_0(c : std_logic_vector(3 downto 0)) return std_logic_vector is
variable gfmul_0 : std_logic_vector(3 downto 0) ;
begin
gfmul_0(0) := c(0) ; 
gfmul_0(1) := c(1) ; 
gfmul_0(2) := c(2) ; 
gfmul_0(3) := c(3) ; 
    return (gfmul_0) ;
end gfmul_0 ;


END gf_arith ;
