------------------------------------------------------------------------
--                  Generated by RSTK                                 --
--                      rs_encode.vhd                                 --
--                                                                    --
------------------------------------------------------------------------
--
LIBRARY IEEE ;
use IEEE.std_logic_1164.all ;
--
library IEEE ;
use   IEEE.std_logic_unsigned.all;
--
library IEEE ;
use   IEEE.NUMERIC_STD.all;
--
library gf_arith ;
use   gf_arith.gf_arith.all;
--
library io_lib ;
use   io_lib.io_utils.all;
--
--library mem_lib ;
--use   mem_lib.mem_lib.all;
--
entity berl_mas  is port( rst_n : IN std_logic;
                      clk : IN std_logic;
                      start_berl : IN std_logic;
                      s0: IN std_logic_vector(3 downto 0);
                      s1: IN std_logic_vector(3 downto 0);
                      l0: OUT std_logic_vector(3 downto 0);
                      l1: OUT std_logic_vector(3 downto 0);
                      start_loc_search : OUT std_logic 
                      ) ;
end berl_mas ;

architecture rtl of berl_mas is
-- Locals
--    constant  N : integer := 94 ;
--    constant  K : integer := 88 ;
-- V=2*v
    constant  V : std_logic_vector := "10" ;


-- Delta_R
    signal delta_r : std_logic_vector(3 downto 0);
    signal inv_delta_r : std_logic_vector(3 downto 0);

-- L Count
    signal L   : std_logic_vector(1 downto 0);
    signal Lx2 : std_logic_vector(1 downto 0);  -- 2 * L

-- r Count
    signal r        : std_logic_vector(1 downto 0);
    signal rminus_1 : std_logic_vector(1 downto 0);

-- j Count - used for Delta R calculation
    signal j : std_logic_vector(1 downto 0);

-- Polynomial Lenght Count
    signal Poly_Len_Cnt: std_logic_vector(1 downto 0);


-- Syndrome Delta R calcultor
    signal syn_sel : std_logic_vector(1 downto 0);
    signal lam_sel : std_logic_vector(1 downto 0);
    signal delta_syn : std_logic_vector(3 downto 0);
    signal delta_lam : std_logic_vector(3 downto 0);
    signal delta_r_calc : std_logic_vector(3 downto 0);
    signal delta_r_mul : std_logic_vector(3 downto 0);

-- Berl_SM States
   type berl_sm_states is (
        Berl_s0,
        Berl_s1,
        Berl_s2,
        Berl_s3,
        Berl_s4,
        Berl_s5,
        Berl_s6,
        Berl_s7,
        Berl_s8,
        Berl_s9,
        Berl_s10,
        Berl_s11,
        Berl_s12 
  ) ;
-- Unit Control State Machine

    signal Berl_SM : berl_sm_states ;
    signal loc_srch : std_logic ;

--
-- B(x) register control modes
--
    signal B_x_Q : std_logic_vector(11 downto 0);
    signal B_x_Op : std_logic_vector(2 downto 0);

--
-- L(x) register control modes
--
    signal L_x_Q : std_logic_vector(11 downto 0);
    signal L_x_Op : std_logic_vector(2 downto 0);

--
-- T(x) register control modes
--
    signal T_x_Q : std_logic_vector(11 downto 0);
    signal T_x_Op: std_logic_vector (2 downto 0);

--
-- R(x) register control modes
--
    signal R_0_Q : std_logic_vector(11 downto 0);
    signal R_1_Q : std_logic_vector(11 downto 0);
    signal R_2_Q : std_logic_vector(11 downto 0);

    signal R_2_din : std_logic_vector(3 downto 0);
    signal R_0_din : std_logic_vector(11 downto 0);

    signal R_0_Op : std_logic_vector(2 downto 0);
    signal R_1_Op : std_logic_vector(2 downto 0);
    signal R_2_Op : std_logic_vector(2 downto 0);
    signal R_1_add : std_logic_vector(3 downto 0);
    signal R_0_mul : std_logic_vector(3 downto 0);
    signal R_1_mul : std_logic_vector(3 downto 0);

--
--  Register control op modes
--
    constant x_nop       : std_logic_vector(2 downto 0) := "000" ;
    constant x_load      : std_logic_vector(2 downto 0) := "001" ;
    constant x_shft_l_z  : std_logic_vector(2 downto 0) := "010" ;
    constant x_shft_l    : std_logic_vector(2 downto 0) := "011" ;
    constant x_shft_r_z  : std_logic_vector(2 downto 0) := "100" ;
    constant x_shft_r    : std_logic_vector(2 downto 0) := "101" ;
    constant x_init_zero : std_logic_vector(2 downto 0) := "110" ;
    constant x_init_one  : std_logic_vector(2 downto 0) := "111" ;

--
--
   signal l_0 : std_logic_vector(3 downto 0);
   signal l_1 : std_logic_vector(3 downto 0);
   signal l_2 : std_logic_vector(3 downto 0);
   constant syn_s0 : std_logic_vector(1 downto 0) := "00" ;
   constant syn_s1 : std_logic_vector(1 downto 0) := "01" ;
   constant lam_l0 : std_logic_vector(1 downto 0) := "00" ;
   constant lam_l1 : std_logic_vector(1 downto 0) := "01" ;
   constant lam_l2 : std_logic_vector(1 downto 0) := "10" ;

   component poly_reg is port (
                         rst_n   : IN std_logic ;
                         clk     : IN std_logic ;
                         op_code : IN std_logic_vector(2 downto 0) ;
                         sd_in   : IN std_logic_vector(3 downto 0) ;
                         ld_in   : IN std_logic_vector(11 downto 0) ;
                         d_out   : OUT std_logic_vector(11 downto 0)
                       );
   end component ;

--
-- GF Inverse ROM Table
--
-- outputs the inverse of a^n (1/a^n) from input of a^n
--
-- Address => a^n
-- Data Out => 1/a^n
--
--
--------------------------------------------------------------------------
--
--     ROM Tables for Berlekamp-Massey Algorithm
--
--     This table is loaded into RAM during initialization
--------------------------------------------------------------------------
component spram_block is
  generic ( RAM_NUM_WORDS : integer ;
            RAM_WIDTH_A   : integer ;
            RAM_WIDTH_D   : integer ;
      RAM_FILE      : string
       );
  port (clk  : in std_logic;
        we   : in std_logic;
        addr : in std_logic_vector(RAM_WIDTH_A-1 downto 0);
        di   : in std_logic_vector(RAM_WIDTH_D-1 downto 0);
        do   : out std_logic_vector(RAM_WIDTH_D-1 downto 0)
    );
end component;

begin

    start_loc_search <= loc_srch ;

  berl_rom: spram_block
       generic map( RAM_NUM_WORDS => 16,
                  RAM_WIDTH_A => 4,
          RAM_WIDTH_D => 4,
          RAM_FILE => "gf_inv_rom.hex")
       port map(
        clk => clk,
        we => '0',
        addr => delta_r,
        di => "0000",
        do => inv_delta_r
    ) ;
------------------------------------------------------------------------------------------
--
--  Control State Machine
--
--
process(rst_n, clk)
begin
    if (rst_n <= '0')then
            delta_r <= (OTHERS => '0') ;
            r <= (OTHERS => '0') ;
            j <= (OTHERS => '0') ;
            L <= (OTHERS => '0') ;
            delta_r <= (OTHERS => '0') ;
            Poly_Len_Cnt <= (OTHERS => '0') ;
            Berl_SM <= Berl_s0 ;
    elsif (clk'event and clk = '1')then
        case Berl_SM is
            when Berl_s0 =>
                if (start_berl = '1') then
                        r <= (OTHERS => '0') ;
                        L <= (OTHERS => '0') ;
                        Berl_SM <=  Berl_s1 ;
                end if ;

            when Berl_s1 =>
                     delta_r <= (OTHERS => '0') ;
                     j <= (OTHERS => '0') ;
                     Berl_SM <= Berl_s2 ;

            when Berl_s2 =>                 -- Calculate delta r
                         if (j <= L ) then
                             delta_r <= delta_r_calc ;
                             j <= j + 1 ;
                             Berl_SM <= Berl_s2 ;
                         else
                             r <= r + 1 ;
                             Berl_SM <= Berl_s3 ;
                         end if ;

            when Berl_s3 =>
                         if (delta_r <= 0) then
                             Berl_SM <= Berl_s11 ;
                         else
                             Berl_SM <= Berl_s4 ;
                             Poly_Len_Cnt <= (OTHERS => '0') ;
                         end if ;

            when Berl_s4 =>
                         Berl_SM <= Berl_s5 ;

            when Berl_s5 =>                    -- Calculate delta_r*x*B(x)
                         if (Poly_Len_Cnt < V) then
                             Berl_SM <= Berl_s5 ;
                             Poly_Len_Cnt <= Poly_Len_Cnt + 1 ;
                         else
                             Berl_SM <= Berl_s6 ;
                             Poly_Len_Cnt <= (OTHERS => '0') ;
                         end if ;

            when Berl_s6 =>                  -- Calculate T(x) = L(x) + delta_r*x*B(x)
                         if (Poly_Len_Cnt < V) then
                             Berl_SM <= Berl_s6 ;
                             Poly_Len_Cnt <= Poly_Len_Cnt + 1 ;
                         else
                             Berl_SM <= Berl_s7 ;
                         end if ;

            when Berl_s7 =>
                         if (Lx2 <= rminus_1) then
                             Berl_SM <= Berl_s8 ;
                             Poly_Len_Cnt <= (OTHERS => '0') ;
                         else
                             Berl_SM <= Berl_s10 ;
                         end if ;

            when Berl_s8 =>                   -- Calculate (delta_r^-1)*L(x)
                         if (Poly_Len_Cnt < V) then
                             Berl_SM <= Berl_s8 ;
                             Poly_Len_Cnt <= Poly_Len_Cnt + 1 ;
                         else
                             Berl_SM <= Berl_s9 ;
               end if ;

            when Berl_s9 =>
                         L <= r - L ;
                         Berl_SM <= Berl_s11 ;

            when Berl_s10 =>
                         Berl_SM <= Berl_s11 ;

            when Berl_s11 =>
                         if (r = V) then
                             Berl_SM <= Berl_s12 ;
                         else
                             Berl_SM <= Berl_s1 ;
                             j <= (OTHERS => '0') ;
                         end if ;

            when Berl_s12 =>
                         Berl_SM <= Berl_s0 ;

            when OTHERS =>
                         Berl_SM <= Berl_s0 ;
        end case ;
  end if ;
end process ;
-- Syndrome selection
     syn_sel <= r - j ;

   with syn_sel select
         delta_syn <=  s0 when syn_s0,
                       s1 when syn_s1,
              (OTHERS => '0')  when others ;

-- Lambda selection
     lam_sel <= j ;

   with lam_sel select
         delta_lam <= l_0 when lam_l0,
                      l_1 when lam_l1,
              (OTHERS => '0')  when others ;

     delta_r_mul <= gfmul_ab(delta_syn, delta_lam)  ;
     delta_r_calc <= delta_r_mul xor delta_r ;

      Lx2(1 downto 0) <= L(0 downto 0) & '0' ;
      rminus_1 <= r - 1 ;

      B_x_Op <=  x_init_one when (Berl_SM = Berl_s0 and start_berl = '1') else
                      x_nop when (Berl_SM = Berl_s7 and (Lx2 <= rminus_1)) else
                 x_shft_l_z when (Berl_SM = Berl_s7 and (Lx2 > rminus_1)) else
                 x_shft_l_z when (Berl_SM = Berl_s3 and delta_r = 0 ) else
                     x_load when (Berl_SM = Berl_s9) else
                     x_nop ;

      L_x_Op <=  x_init_one when (Berl_SM = Berl_s0 and start_berl = '1') else
                      x_nop when (Berl_SM = Berl_s7 and (Lx2 <= rminus_1)) else
                     x_load when (Berl_SM = Berl_s7 and (Lx2 > rminus_1)) else
                     x_load when (Berl_SM = Berl_s9) else
                     x_load when (Berl_SM = Berl_s10) else
                      x_nop ;

      T_x_Op <= x_init_zero when (Berl_SM = Berl_s0 and start_berl = '1') else
                     x_load when (Berl_SM = Berl_s6 and Poly_Len_Cnt = V) else
                      x_nop ;

      R_0_Op <= x_init_zero when (Berl_SM = Berl_s0 and start_berl = '1') else
                     x_load when (Berl_SM = Berl_s3 and delta_r /= 0 ) else
                   x_shft_l when (Berl_SM = Berl_s4 ) else
                 x_shft_l_z when (Berl_SM = Berl_s5 and Poly_Len_Cnt < V ) else
                     x_load when (Berl_SM = Berl_s5 and Poly_Len_Cnt = V ) else
                 x_shft_l_z when (Berl_SM = Berl_s6 ) else
                     x_nop ;

      R_1_Op <= x_init_zero when (Berl_SM = Berl_s0 and start_berl = '1') else
                     x_load when (Berl_SM = Berl_s3 and delta_r /= 0 ) else
                 x_shft_l_z when (Berl_SM = Berl_s6 ) else
                     x_load when (Berl_SM = Berl_s7 and (Lx2 <= rminus_1)) else
                 x_shft_l_z when (Berl_SM = Berl_s8  and Poly_Len_Cnt < V) else
                     x_nop ;

      R_2_Op <= x_init_zero when (Berl_SM = Berl_s0 and start_berl = '1') else
                   x_shft_l when (Berl_SM = Berl_s4 ) else
                   x_shft_l when (Berl_SM = Berl_s5 ) else
                   x_shft_l when (Berl_SM = Berl_s6 ) else
                   x_shft_l when (Berl_SM = Berl_s8 and Poly_Len_Cnt < V ) else
                   x_nop ;

--
--
--  Register R_0
--
    R_0 : poly_reg port map(rst_n => rst_n,
                    clk => clk,
                    op_code => R_0_Op,
                    sd_in => "0000",
                    ld_in => R_0_din,
                    d_out => R_0_Q
                    ) ;

     R_0_din <=  R_2_Q when (Berl_SM = Berl_s5 and Poly_Len_Cnt = V) else B_x_Q ;
     R_0_mul <= gfmul_ab(delta_r, R_0_Q(7 downto 4)) ;

--
--
--  Register R_1
--
    R_1 :  poly_reg port map(rst_n => rst_n,
                    clk => clk,
                    op_code => R_1_Op,
                    sd_in => "0000",
                    ld_in => L_x_Q,
                    d_out => R_1_Q
                   ) ;

    R_1_add <= R_1_Q(7 downto 4) xor R_0_Q(7 downto 4) ;
    R_1_mul <= gfmul_ab(inv_delta_r(3 downto 0), R_1_Q(7 downto 4)) ;

--
--
--  Register R_2
--
    R2 : poly_reg port map(rst_n => rst_n,
                  clk => clk,
                  op_code => R_2_Op,
                  sd_in => R_2_din,
                  ld_in => "000000000000",
                  d_out => R_2_Q
                 ) ;

     R_2_din <= R_0_mul when (Berl_SM = Berl_s5) else
                R_1_add when (Berl_SM = Berl_s6) else
                R_1_mul when (Berl_SM = Berl_s8) else
                (OTHERS => '0') ;


--
--        B(x)
--
    B_X : poly_reg port map(rst_n => rst_n,
                   clk => clk,
                   op_code => B_x_Op,
                   sd_in => "0000",
                   ld_in => R_2_Q,
                   d_out => B_x_Q
                  ) ;

--
--        L(x)
--
    L_x : poly_reg port map( rst_n => rst_n,
                   clk => clk,
                   op_code => L_x_Op,
                   sd_in => "0000",
                   ld_in => T_x_Q,
                   d_out => L_x_Q
                  ) ;

    l0 <= L_x_Q(3 downto 0);
    l1 <= L_x_Q(7 downto 4);

    l_0 <= L_x_Q(3 downto 0);
    l_1 <= L_x_Q(7 downto 4);

--
--        T(x)
--
    T_x : poly_reg port map(rst_n => rst_n,
                   clk => clk,
                   op_code => T_x_Op,
                   sd_in => "0000",
                   ld_in => R_2_Q,
                   d_out => T_x_Q
                 ) ;

process(rst_n, clk)
begin
    if (rst_n = '0') then
            loc_srch <= '0' ;
  elsif (clk'event and clk = '1') then
         if (Berl_SM = Berl_s12) then
            loc_srch <= '1' ;
         else
            loc_srch <= '0' ;
     end if ;
  end if ;
end process ;

END ;
