------------------------------------------------------------------------
--                  Generated by RSTK                                 --
--                      rs_forney.vhd                                 --
--                                                                    --
------------------------------------------------------------------------
--
LIBRARY IEEE ;
use IEEE.std_logic_1164.all ;
--
library IEEE ;
use     IEEE.std_logic_unsigned.all;
--
library IEEE ;
use     IEEE.NUMERIC_STD.all;
--
library gf_arith ;
use     gf_arith.gf_arith.all;
--
library io_lib ;
use     io_lib.io_utils.all;
--

entity forney is port ( rst_n : IN std_logic;
                        clk : IN std_logic;
                        start_forney : IN std_logic;
                        root_search_done : IN std_logic;
                        s0 : IN std_logic_vector(3 downto 0);
                        s1 : IN std_logic_vector(3 downto 0);
                        l0 : IN std_logic_vector(3 downto 0);
                        l1 : IN std_logic_vector(3 downto 0);
                        lroot0 : IN std_logic_vector(3 downto 0);
                        n_roots : IN std_logic_vector(3 downto 0);
                        corr_err_val0 : OUT std_logic_vector(3 downto 0);
                        omega_dlam_rdy : OUT std_logic;
                        forney_done : OUT std_logic
                        ) ;
end forney ;

architecture rtl of forney is
-- Locals

    signal    Om_x : std_logic_vector(3 downto 0);
    signal    Om_0 : std_logic_vector(3 downto 0);
    signal    Om_1 : std_logic_vector(3 downto 0);
    signal    Om_reg : std_logic_vector(3 downto 0);

--  Forney Control SM

    type forney_states is (
        Forney_s0,
        Forney_s1,
        Forney_s2,
        Forney_s3,
        Forney_s4,
        Forney_s5,
        Forney_s6,
        Forney_s7,
        Forney_s8,
        Forney_s9,
        Forney_s10  ) ;

    signal Forney_SM : forney_states;

--
    constant    syn_s0  : std_logic_vector(1 downto 0) := "00" ;
    constant    syn_s1  : std_logic_vector(1 downto 0) := "01" ;

    constant    lam_l0  : std_logic_vector(1 downto 0) := "00" ;
    constant    lam_l1  : std_logic_vector(1 downto 0) := "01" ;

    constant    Om_r0   : std_logic_vector(1 downto 0) := "00" ;
    constant    Om_r1   : std_logic_vector(1 downto 0) := "01" ;
--
    signal lam_mux : std_logic_vector(3 downto 0);
    signal om_mux : std_logic_vector(3 downto 0);

    signal K0 : std_logic_vector(3 downto 0);
    signal K1 : std_logic_vector(3 downto 0);

    signal syn : std_logic_vector(3 downto 0);
    signal syn_sel : std_logic_vector(1 downto 0);

    signal lam : std_logic_vector(3 downto 0);
    signal lam_sel: std_logic_vector(1 downto 0);
    signal i : std_logic_vector(1 downto 0);

    signal j : std_logic_vector(1 downto 0);
    signal cnt : std_logic_vector(1 downto 0);

    signal n_root_cnt : std_logic_vector(3 downto 0);
    signal mux_poly_cnt  : std_logic_vector(1 downto 0);
    signal Sel_F  : std_logic;

    signal a_n : std_logic_vector(3 downto 0);
    signal R_an : std_logic_vector(3 downto 0);

    signal k_om : std_logic_vector(3 downto 0);
    signal R_k_om : std_logic_vector(3 downto 0);

    signal k_lam : std_logic_vector(3 downto 0);
    signal R_k_lam : std_logic_vector(3 downto 0);

    signal R_Om : std_logic_vector(3 downto 0);

    signal Omega : std_logic_vector(3 downto 0);
    signal R_Ei_0 : std_logic_vector(3 downto 0);

    signal om_lam_calc : std_logic_vector(3 downto 0);
    signal inv_k_lam : std_logic_vector(3 downto 0);
    signal norm : std_logic_vector(3 downto 0);

    signal Decode_Done : std_logic ;
--------------------------------------------------------------------------
--
--     ROM Instanciation for Forney Algorithm
--
--     This table is loaded into RAM during initialization
--------------------------------------------------------------------------
    signal gf_alpha_rom_adrs : std_logic_vector(3 downto 0);
    signal gf_alpha : std_logic_vector(3 downto 0);

    signal inv_alpha_rom_adrs : std_logic_vector(3 downto 0);
    signal gf_inv_alpha : std_logic_vector(3 downto 0);


component spram_block is
  generic ( RAM_NUM_WORDS : integer ;
            RAM_WIDTH_A   : integer ;
            RAM_WIDTH_D   : integer ;
            RAM_FILE      : string 
           );
  port (clk  : in std_logic;
        we   : in std_logic;
        addr : in std_logic_vector(RAM_WIDTH_A-1 downto 0);
        di   : in std_logic_vector(RAM_WIDTH_D-1 downto 0);
        do   : out std_logic_vector(RAM_WIDTH_D-1 downto 0)
        );
end component;

begin
--------------------------------------------------------------------------
--
--     ROM Tables for Forney Algorithm
--
--------------------------------------------------------------------------
--
-- GF ROM Table a^n
--
-- GF256 ROM table for a^n
--
  forney_alpha_rom: spram_block
       generic map( RAM_NUM_WORDS => 16,
                    RAM_WIDTH_A => 4,
                    RAM_WIDTH_D => 4,
                    RAM_FILE => "gf_alpha_rom.hex")
       port map(
        clk => clk,
        we => '0',
        addr => gf_alpha_rom_adrs,
        di => "0000",
        do => gf_alpha
        ) ;
--
-- GF ROM Table Inverse a^n
--
--
  forney_inv_rom: spram_block
       generic map( RAM_NUM_WORDS => 16,
                    RAM_WIDTH_A => 4,
                    RAM_WIDTH_D => 4,
                    RAM_FILE => "gf_inv_rom.hex")
       port map(
        clk => clk,
        we => '0',
        addr => inv_alpha_rom_adrs,
        di => "0000",
        do => gf_inv_alpha
        ) ;

--
-- Forney Algorithm control 
--
process(rst_n, clk)
begin
    if (rst_n = '0') then
            Forney_SM <= Forney_s0  ;
            cnt <= "00" ;
            j <= "01" ;
            i <= "01" ;
            n_root_cnt <= (OTHERS => '0') ;
            mux_poly_cnt <=  (OTHERS => '0') ;
            Sel_F <= '0' ;
    elsif (clk'event and clk = '1')then
         case Forney_SM is
             when Forney_s0 =>
                     if (start_forney = '1') then
                             Forney_SM <= Forney_s1  ;
                             j <= "01" ;
                             i <= "01" ;
                             cnt <= "00" ;
                     else
                         Forney_SM <= Forney_s0  ;
                     end if ;

             when Forney_s1 =>
                     if  (j > 0) then
                             Forney_SM <= Forney_s1  ;
                             j <= j - 1 ;
                     else
                             Forney_SM <= Forney_s2  ;
                             cnt <= cnt + 1 ;
                     end if ;

             when Forney_s2 =>
                     if (cnt = 2) then
                             Forney_SM <= Forney_s3  ;
                     else
                             Forney_SM <= Forney_s1  ;
                             j <= i - 1 ;
                             i <= i - 1 ;
                     end if ;

             when Forney_s3 =>
                     Forney_SM <= Forney_s4  ;

                     n_root_cnt <= (OTHERS => '0') ;
                     mux_poly_cnt <= (OTHERS => '0') ;

             when Forney_s4 =>
                     if (n_root_cnt = n_roots ) then
                         Forney_SM <= Forney_s8  ;
                     else
                         Forney_SM <= Forney_s5  ;
                     end if ;

             when Forney_s5 =>
                     if (mux_poly_cnt = 0) then
                             Forney_SM <= Forney_s6  ;
                     else
                             mux_poly_cnt <= mux_poly_cnt + 1 ;
                             Forney_SM <= Forney_s5  ;
                     end if ;

             when Forney_s6 =>
                     Sel_F <= '1' ;
                     Forney_SM <= Forney_s7  ;

             when Forney_s7 =>
                     n_root_cnt <= n_root_cnt + 1 ;
                     mux_poly_cnt <= "00" ;
                     Sel_F <= '0' ;
                     Forney_SM <= Forney_s4  ;

             when Forney_s8 =>
                     Forney_SM <= Forney_s0  ;

             when OTHERS =>
                     Forney_SM <= Forney_s0  ;

         end case ;
    end if ;
end process ;
--
-- Generate Omega(x) polynomial
--
    syn_sel <= i - j ;

    with syn_sel select
        syn <= s0 when  syn_s0,
               s1 when  syn_s1,
                (OTHERS => '0')  when others ;

    lam_sel <= j ;

    with lam_sel select
         lam <= l0 when lam_l0,
                l1 when lam_l1,
                (OTHERS => '0')  when others ;

     Om_x <= gfmul_ab(syn,lam) ;

--
--
--
process(rst_n, clk)
begin
    if (rst_n = '0') then
           Om_reg <= (OTHERS => '0') ;
    elsif (clk'event and clk = '1')then
        if (Forney_SM = Forney_s1) then
            Om_reg <= Om_reg xor Om_x ;
        elsif (Forney_SM = Forney_s2) then
            Om_reg <= (OTHERS => '0') ;
        end if ;
    end if ;
end process ;
--
--
--
process(rst_n, clk)
begin
    if (rst_n = '0') then
           Om_0 <= (OTHERS => '0') ;
           Om_1 <= (OTHERS => '0') ;
    elsif (clk'event and clk = '1')then
      if (Forney_SM = Forney_s2) then
        case cnt is
            when "01" => 
                   Om_1 <= Om_reg ;

            when "10" => 
                   Om_0 <= Om_reg ;

            when OTHERS =>

        end case ;
      end if ;
   end if ;
end process ;

--
-- Compute powers of a^n for each term in O(x) and L'(x)
--
process(rst_n, clk)
begin
    if (rst_n = '0') then
           R_an <= (OTHERS => '0') ;
    elsif (clk'event and clk = '1')then
        if (Forney_SM = Forney_s3 or Forney_SM = Forney_s7) then
            R_an(0) <= '1' ;
            R_an(3 downto 1) <= (OTHERS => '0') ;
        elsif (Forney_SM = Forney_s5) then
            R_an <= a_n ;
        end if ;
    end if ;
end process ;

     gf_alpha_rom_adrs <= lroot0 when (n_root_cnt = 0) else
                          (OTHERS => '0') ;

     a_n <= gfmul_ab(gf_alpha,R_an) ;

--
-- Compute Omega(root of lamda)
--
     with mux_poly_cnt select
          om_mux <= Om_0 when Om_r0,
                    Om_1 when Om_r1,
                     (OTHERS => '0') when others ;

    k_om <= gfmul_ab(R_an, om_mux) ;

--
-- Compute  O(x)
--
process(rst_n, clk)
begin
    if (rst_n = '0') then
           R_k_om <= (OTHERS => '0') ;
    elsif (clk'event and clk = '1')then
        if (Forney_SM = Forney_s3 or Forney_SM = Forney_s7 ) then
            R_k_om <= (OTHERS => '0') ;
        elsif (Forney_SM = Forney_s5) then
            R_k_om <= R_k_om xor k_om ;
        end if ;
    end if ;

end process ;

--
-- Compute derivative (root of lamda)
--
    -- Derivative of lamda is created by zeroing even powers
      lam_mux <= l1 when (mux_poly_cnt = lam_l0) else
                 (OTHERS => '0') ;

     k_lam <= gfmul_ab(R_an, lam_mux) ;

--
-- Compute  L'(x) 
--
process(rst_n, clk)
begin
    if (rst_n = '0') then
           R_k_lam <= (OTHERS => '0') ;
    elsif (clk'event and clk = '1')then
        if (Forney_SM = Forney_s3 or Forney_SM = Forney_s7 ) then
            R_k_lam <= (OTHERS => '0') ;
        elsif (Forney_SM = Forney_s5) then
            R_k_lam <= R_k_lam xor k_lam ;
        end if ;
    end if ;

end process ;

--
-- Store  O(x)/L'(x)
--
process(rst_n, clk)
begin
    if (rst_n = '0') then
           R_Om <= (OTHERS => '0') ;
    elsif (clk'event and clk = '1')then
        if (Forney_SM = Forney_s3 or Forney_SM = Forney_s7 ) then
            R_Om <= (OTHERS => '0') ;
        elsif (Forney_SM = Forney_s6) then
            R_Om <= om_lam_calc ;
        end if ;
    end if ;
end process ;

    K0 <=  R_k_om when (Sel_F = '0') else norm ;
    K1 <=  inv_k_lam when (Sel_F = '0') else R_Om ;

    norm <= "0001" ;

    inv_alpha_rom_adrs <= R_k_lam ;
    inv_k_lam <= gf_inv_alpha ;

    om_lam_calc <= gfmul_ab(K0, K1) ;

--
-- Store Ei values to correct message
--
process(rst_n, clk)
begin
    if (rst_n = '0') then
           R_Ei_0 <= (OTHERS => '0') ;
    elsif (clk'event and clk = '1')then
        if (Forney_SM = Forney_s7) then
            case n_root_cnt is
                when "0000" =>
                   R_Ei_0 <= om_lam_calc ;

                when OTHERS =>

            end case ;
        end if ;
    end if ;

end process ;
    corr_err_val0 <= R_Ei_0 ;

--
-- Indicate correction values ready
--
process(rst_n, clk)
begin
    if (rst_n = '0') then
           Decode_Done <= '0' ;
    elsif (clk'event and clk = '1')then
        if (Forney_SM = Forney_s8) then
           Decode_Done <= '1' ;
        else
           Decode_Done <= '0' ;
        end if ;
    end if ;
end process ;

    forney_done <= Decode_Done ;

end ;

