------------------------------------------------------------------------
--                  Generated by RSTK                                 --
--                      rs_polyreg.vhd                                --
--                                                                    --
------------------------------------------------------------------------
--
LIBRARY IEEE ;
use IEEE.std_logic_1164.all ;
--
library IEEE ;
use   IEEE.std_logic_unsigned.all;
--
library IEEE ;
use   IEEE.NUMERIC_STD.all;
--
entity poly_reg is port (rst_n   : IN std_logic ;
                         clk     : IN std_logic ;
                         op_code : IN std_logic_vector(2 downto 0) ;
                         sd_in   : IN std_logic_vector(3 downto 0) ;
                         ld_in   : IN std_logic_vector(11 downto 0) ;
                         d_out   : OUT std_logic_vector(11 downto 0)
                        );
end poly_reg ;

architecture rtl of poly_reg is
--
-- Registers
--
    signal      r_0 : std_logic_vector(3 downto 0) ;
    signal      r_1 : std_logic_vector(3 downto 0) ;
    signal      r_2 : std_logic_vector(3 downto 0) ;

    signal    reg_out : std_logic_vector(11 downto 0) ;

--
--  Register control modes 
--
    constant nop       : std_logic_vector(2 downto 0) := "000" ;
    constant load      : std_logic_vector(2 downto 0) := "001" ;
    constant shift_l_z : std_logic_vector(2 downto 0) := "010" ;
    constant shift_l   : std_logic_vector(2 downto 0) := "011" ;
    constant shift_r_z : std_logic_vector(2 downto 0) := "100" ;
    constant shift_r   : std_logic_vector(2 downto 0) := "101" ;
    constant init_zero : std_logic_vector(2 downto 0) := "110" ;
    constant init_one  : std_logic_vector(2 downto 0) := "111" ;

begin
--
--
--
process(rst_n, clk)
begin
    if (rst_n = '0') then
            r_0 <= (OTHERS => '0') ;
            r_1 <= (OTHERS => '0') ;
            r_2 <= (OTHERS => '0') ;
    elsif (clk'event and clk = '1') then
        case op_code is
            when nop =>

            when load =>
                    r_0 <= ld_in(3 downto 0) ;
                    r_1 <= ld_in(7 downto 4) ;
                    r_2 <= ld_in(11 downto 8) ;
            when shift_l_z =>
                    r_0 <= (OTHERS => '0') ;
                    r_1 <= r_0 ;
                    r_2 <= r_1 ;
            when shift_l =>
                    r_0 <= sd_in(3 downto 0) ;
                    r_1 <= r_0 ;
                    r_2 <= r_1 ;
            when shift_r_z =>
                    r_0 <= r_1 ;
                    r_1 <= r_2 ;
                    r_2 <= (OTHERS => '0') ;
            when shift_r =>
                    r_0 <= r_1 ;
                    r_1 <= r_2 ;
                    r_2 <= sd_in(3 downto 0) ;
            when init_zero =>
                    r_0 <= (OTHERS => '0') ;
                    r_1 <= (OTHERS => '0') ;
                    r_2 <= (OTHERS => '0') ;
            when init_one =>
                    r_0(0) <= '1' ;
                    r_0(3 downto 1) <= (OTHERS => '0')  ;
                    r_1 <= (OTHERS => '0') ;
                    r_2 <= (OTHERS => '0') ;
            when OTHERS =>
        end case ;
  end if ;
end process ;

        reg_out(11 downto 0) <= r_2 
                              & r_1 
                              & r_0 ; 
        d_out <= reg_out ;

END ;
