------------------------------------------------------------------------
--                  Generated by RSTK                                 --
--                      rs_encode.vhd                                  --
--                                                                    --
------------------------------------------------------------------------
--
--
LIBRARY IEEE ;
use IEEE.std_logic_1164.all ;
--
library IEEE ;
use     IEEE.std_logic_unsigned.all;
--
library IEEE ;
use     IEEE.NUMERIC_STD.all;
--
--
library gf_arith ;
use     gf_arith.gf_arith.all;
--
--
entity dec_syn_calc is port( rst_n   : IN std_logic ;
                             init    : IN std_logic ;
                             clk     : IN std_logic ;
                             enb_dec : IN std_logic ;
                             d_in : IN std_logic_vector(3 downto 0) ;
                             s1   : OUT std_logic_vector(3 downto 0) ;
                             s2   : OUT std_logic_vector(3 downto 0) ;
                             syn_zero : OUT std_logic 
                             ) ;
end dec_syn_calc ;

architecture rtl of dec_syn_calc is

-- Local signals

    signal    s1_r : std_logic_vector(3 downto 0);
    signal    s2_r : std_logic_vector(3 downto 0);

begin

process(rst_n ,clk)
begin
    if (rst_n = '0') then
           s1_r <= (OTHERS => '0') ;
           s2_r <= (OTHERS => '0') ;
    elsif (clk'event and clk ='1') then
        if (init = '1') then
           s1_r <= (OTHERS => '0') ;
           s2_r <= (OTHERS => '0') ;
        elsif (enb_dec = '1') then
           s1_r <= gfmul_0(s1_r) xor d_in ;
           s2_r <= gfmul_1(s2_r) xor d_in ;
        end if ;
    end if ;
end process ;

    -- Output Syndromes

   s1 <= s1_r ;
   s2 <= s2_r ;

    -- If  (S1+S2+...S5) equals zero then no error occured 
  syn_zero <= '1' when (s1_r=0 and 
                        s2_r=0 )  
                  else '0';

END ;

