/**************************************************************/
/*                                                            */
/*            rsccg.h                                         */
/*                                                            */
/*    Generate Reed-Solomon Code Core Generator               */
/*    header file                                             */
/*                                                            */
/*                                                            */
/*                                                            */
/**************************************************************/
//
// Primitive Field Generator Polynomials 
//
//
//
// NOTE: All Polynomials are represented in reversed order
// First element in array is x^0
//
//
// P(x) = x^4 + x^1 + 1 => 10011
unsigned char gf2_e4[5] = {'1','1','0','0','1'} ;
// p(x) = x^5 + x^2 + 1 => 100101
unsigned char gf2_e5[6] = {'1','0','1','0','0','1'} ;
// P(x) = x^8 + x^7 + x^2 + x + 1 => 110000111 
unsigned char gf2_e8_itu[9] = {'1','1','1','0','0','0','0','1','1'} ;
// P(x) = x^8 + x^4 + x^3 + x + 1 => 100011101 
unsigned char gf2_e8_dvb[9] = {'1','0','1','1','1','0','0','0','1'} ;
//
//
//
#define   GF2_E4       0x13        //  GF(2^4) = 19  (base 10)
#define   GF2_E5       0x25        //  GF(2^5) = 37  (base 10)   
#define   GF2_E8_itu   0x187       //  GF(2^8) = 391 (base 10)  ITU381/INTELSAT
#define   GF2_E8_dvb   0x11D       //  GF(2^8) = 285 (base 10)  DVB/CD/ATSC

